/* Desert Nomad */
/* "Age of Mythology" 'random map'. */
/* By: Edward George Hoffman III. */
/* 3/4/2003. Currently: eghiii@attbi.com. */

void main(void)

{

  rmSetStatusText("",0.00);

  rmSetMapSize(1000,1000);
  rmSetSeaLevel(0.0);
  rmSetSeaType("Red sea");
  rmTerrainInitialize("Water");

  // Land.

  int WaterBorder=rmCreateBoxConstraint("Water border", 0.00, 0.00, 1.00,
    1.00, rmRandFloat(0.21, 0.50));
      /* [Above.] 5th digit entry possible change "1.00" to '0.01': also
      looks good. */

  int Desert=rmCreateArea("Desert");
  rmSetAreaTerrainType(Desert, "SandC");
  rmAddAreaConstraint(Desert, WaterBorder);
  rmSetAreaLocation(Desert, 0.5, 0.5);
  rmSetAreaSize(Desert, 0.65, 0.65);
  rmSetAreaMinBlobs(Desert, 250);
  rmSetAreaMaxBlobs(Desert, 250);
  rmSetAreaMinBlobDistance(Desert, 0.0);
  rmSetAreaMaxBlobDistance(Desert, 500.0);
  rmSetAreaBaseHeight(Desert, 2.0);
  rmSetAreaHeightBlend(Desert, 2);
  rmBuildArea(Desert);

  // Ocean life.

  int AvoidLand1=rmCreateTerrainDistanceConstraint("Avoid land1", "land",
    true, 1.0);
  int AvoidLand2=rmCreateTerrainDistanceConstraint("Avoid land2", "land",
    true, 5.0);
  int AvoidLand3=rmCreateTerrainDistanceConstraint("Avoid land3", "land",
    true, 15.0);
  int AvoidLand4=rmCreateTerrainDistanceConstraint("Avoid land4", "land",
    true, 20.0);
  int NearLand=rmCreateTerrainMaxDistanceConstraint("Near land", "land",
    false, 2.0);

  int MahiMahi=rmCreateObjectDef("Mahi mahi");
  rmAddObjectDefConstraint(MahiMahi, AvoidLand2);
  rmAddObjectDefItem(MahiMahi, "Fish - Mahi", 1, 0.0);
  rmSetObjectDefMinDistance(MahiMahi, 0.0);
  rmSetObjectDefMaxDistance(MahiMahi, 500);
  rmPlaceObjectDefAtLoc(MahiMahi, 0, 0.5, 0.5, 30);

  int Salmon=rmCreateObjectDef("Salmon");
  rmAddObjectDefConstraint(Salmon, AvoidLand2);
  rmAddObjectDefItem(Salmon, "Fish - Salmon", 1, 0.0);
  rmSetObjectDefMinDistance(Salmon, 0.0);
  rmSetObjectDefMaxDistance(Salmon, 500);
  rmPlaceObjectDefAtLoc(Salmon, 0, 0.5, 0.5, 30);

  int Whale=rmCreateObjectDef("Whale");
  rmAddObjectDefConstraint(Whale, AvoidLand4);
  rmAddObjectDefItem(Whale, "Whale", 1, 0.0);
  rmSetObjectDefMinDistance(Whale, 0.0);
  rmSetObjectDefMaxDistance(Whale, 500);
  rmPlaceObjectDefAtLoc(Whale, 0, 0.5, 0.5, 15);

  int Orca=rmCreateObjectDef("Orca");
  rmAddObjectDefConstraint(Orca, AvoidLand4);
  rmAddObjectDefItem(Orca, "Orca", 1, 0.0);
  rmSetObjectDefMinDistance(Orca, 0.0);
  rmSetObjectDefMaxDistance(Orca, 500);
  rmPlaceObjectDefAtLoc(Orca, 0, 0.5, 0.5, 15);

  int Shark=rmCreateObjectDef("Shark");
  rmAddObjectDefConstraint(Shark, AvoidLand3);
  rmAddObjectDefItem(Shark, "Shark", 1, 0.0);
  rmSetObjectDefMinDistance(Shark, 0.0);
  rmSetObjectDefMaxDistance(Shark, 500);
  rmPlaceObjectDefAtLoc(Shark, 0, 0.5, 0.5, 20);
   
  int HawksbillTurtle=rmCreateObjectDef("Hawksbill turtle");
  rmAddObjectDefConstraint(HawksbillTurtle, AvoidLand3);
  rmAddObjectDefItem(HawksbillTurtle, "Hawksbill", 1, 0.0);
  rmSetObjectDefMinDistance(HawksbillTurtle, 0.0);
  rmSetObjectDefMaxDistance(HawksbillTurtle, 500);
  rmPlaceObjectDefAtLoc(HawksbillTurtle, 0, 0.5, 0.5, 15);

  int Seaweed=rmCreateObjectDef("Seaweed");
  rmAddObjectDefConstraint(Seaweed, AvoidLand1);
  rmAddObjectDefItem(Seaweed, "Seaweed", rmRandInt(1, 4),
    rmRandFloat(3.0, 10.0));
  rmSetObjectDefMinDistance(Seaweed, 0.0);
  rmSetObjectDefMaxDistance(Seaweed, 500);
  rmPlaceObjectDefAtLoc(Seaweed, 0, 0.5, 0.5, 75);

  int ShipWreck=rmCreateObjectDef("Shipwreck");
  rmAddObjectDefConstraint(ShipWreck, NearLand);
  rmAddObjectDefItem(ShipWreck, "Shipwreck", 1, 0.0);
  rmSetObjectDefMinDistance(ShipWreck, 0.0);
  rmSetObjectDefMaxDistance(ShipWreck, 500);
  rmPlaceObjectDefAtLoc(ShipWreck, 0, 0.5, 0.5, 15);

  rmSetStatusText("", 0.05);

  // Elevation.

  int AvoidWater1=rmCreateTerrainDistanceConstraint("Avoid water1",
    "water", true, 5.0);
  int AvoidWater2=rmCreateTerrainDistanceConstraint("Avoid water2",
    "water", true, 15.0);

  for(i=0; <100)
  {
    int Elevation=rmCreateArea("Elevation"+i, Desert);
    rmAddAreaConstraint(Elevation, AvoidWater2);
    rmSetAreaTerrainType(Elevation, "SandD");
    rmSetAreaSize(Elevation, rmAreaTilesToFraction(100),
      rmAreaTilesToFraction(200));
    rmSetAreaMinBlobs(Elevation, 20);
    rmSetAreaMaxBlobs(Elevation, 20);
    rmSetAreaMinBlobDistance(Elevation, 0);
    rmSetAreaMaxBlobDistance(Elevation, 40);
    rmSetAreaBaseHeight(Elevation, rmRandFloat(0.0, 2.0));
    rmSetAreaHeightBlend(Elevation, 1); 
      // [Above.] "1" is best: '2' flattens elevation entirely.
    rmSetAreaCoherence(Elevation, 0.0);
    rmBuildArea(Elevation);
  }

  rmSetStatusText("", 0.10);

  int ClassSavannahWaterHole=rmDefineClass("Savannah water hole");
  int AvoidSavannahWaterHole=rmCreateClassDistanceConstraint("Avoid savannah water hole", rmClassID("Savannah water hole"), 3.0);

  // Savannah water hole.

  for(i=0; <25)
  {
    int SavannahWaterHole=rmCreateArea("Savannah water hole"+i, Desert);
    rmAddAreaToClass(SavannahWaterHole, ClassSavannahWaterHole);
    rmAddAreaConstraint(SavannahWaterHole, AvoidWater2);
    rmAddAreaConstraint(SavannahWaterHole, AvoidSavannahWaterHole);
    rmSetAreaWaterType(SavannahWaterHole, "Savannah water hole");
    rmSetAreaSize(SavannahWaterHole, rmAreaTilesToFraction(500),
      rmAreaTilesToFraction(1000));
    rmSetAreaMinBlobs(SavannahWaterHole, 10);
    rmSetAreaMaxBlobs(SavannahWaterHole, 10);
    rmSetAreaMinBlobDistance(SavannahWaterHole, 0.0);
    rmSetAreaMaxBlobDistance(SavannahWaterHole, 20.0);
    rmSetAreaSmoothDistance(SavannahWaterHole, 0);
    rmBuildArea(SavannahWaterHole);

    int WaterLily1=rmCreateObjectDef("Water lily1"+i);
    rmAddObjectDefItem(WaterLily1, "Water lilly", rmRandInt(1, 3), 3.0);
    rmPlaceObjectDefInArea(WaterLily1, 0, SavannahWaterHole, rmRandInt(1, 3));

    int Papyrus1=rmCreateObjectDef("Papyrus1"+i);
    rmAddObjectDefItem(Papyrus1, "Papyrus", rmRandInt(1, 3), 3.0);
    rmPlaceObjectDefInArea(Papyrus1, 0, SavannahWaterHole, rmRandInt(1, 3));

    int Perch1=rmCreateObjectDef("Perch1"+i);
    rmAddObjectDefItem(Perch1, "Fish - perch", 1, 1.0);
    rmPlaceObjectDefInArea(Perch1, 0, SavannahWaterHole, rmRandInt(0, 2));
  } 

  rmSetStatusText("", 0.15);

  int ClassWateringHole=rmDefineClass("Watering hole");
  int AvoidWateringHole=rmCreateClassDistanceConstraint("Avoid watering hole", rmClassID("Watering hole"), 3.0);

  // Watering hole.

  for(i=0; <25)
  {
    int WateringHole=rmCreateArea("Watering hole"+i, Desert);
    rmAddAreaToClass(WateringHole, ClassWateringHole);
    rmAddAreaConstraint(WateringHole, AvoidWater2);
    rmAddAreaConstraint(WateringHole, AvoidSavannahWaterHole);
    rmAddAreaConstraint(WateringHole, AvoidWateringHole);
    rmSetAreaWaterType(WateringHole, "Watering hole");
    rmSetAreaSize(WateringHole, rmAreaTilesToFraction(500),
      rmAreaTilesToFraction(1000));
    rmSetAreaMinBlobs(WateringHole, 10);
    rmSetAreaMaxBlobs(WateringHole, 10);
    rmSetAreaMinBlobDistance(WateringHole, 0.0);
    rmSetAreaMaxBlobDistance(WateringHole, 20.0);
    rmSetAreaSmoothDistance(WateringHole, 0);
    rmBuildArea(WateringHole);

    int WaterLily2=rmCreateObjectDef("Water lily2"+i);
    rmAddObjectDefItem(WaterLily2, "Water lilly", rmRandInt(1, 3), 3.0);
    rmPlaceObjectDefInArea(WaterLily2, 0, WateringHole, rmRandInt(1, 3));

    int Papyrus2=rmCreateObjectDef("Papyrus2"+i);
    rmAddObjectDefItem(Papyrus2, "Papyrus", rmRandInt(1, 3), 3.0);
    rmPlaceObjectDefInArea(Papyrus2, 0, WateringHole, rmRandInt(1, 3));

    int Perch2=rmCreateObjectDef("Perch2"+i);
    rmAddObjectDefItem(Perch2, "Fish - perch", 1, 1.0);
    rmPlaceObjectDefInArea(Perch2, 0, WateringHole, rmRandInt(0, 2));
  } 

  rmSetStatusText("", 0.20);

  // Canyons and cliffs.

  int ClassEgyptianCanyon=rmDefineClass("Egyptian canyon");
  int AvoidEgyptianCanyon=rmCreateClassDistanceConstraint("Avoid egyptian canyon", rmClassID("Egyptian canyon"), 5.0);

  for(i=0; <50)
  {
    int EgyptianCanyon=rmCreateArea("Egyptian canyon"+i, Desert);
    rmAddAreaToClass(EgyptianCanyon, ClassEgyptianCanyon);
    rmAddAreaConstraint(EgyptianCanyon, AvoidWater2);
    rmSetAreaCliffType(EgyptianCanyon, "Egyptian");
    rmSetAreaSize(EgyptianCanyon, rmAreaTilesToFraction(rmRandInt(50, 200)),
      rmAreaTilesToFraction(rmRandInt(100, 800)));
    rmSetAreaMinBlobs(EgyptianCanyon, 10);
    rmSetAreaMaxBlobs(EgyptianCanyon, 10);
    rmSetAreaMinBlobDistance(EgyptianCanyon, 0.0);
    rmSetAreaMaxBlobDistance(EgyptianCanyon, 20.0);
    rmSetAreaCliffEdge(EgyptianCanyon, 1, 0.2, 0.1, 1.0, 0);
    rmSetAreaCliffPainting(EgyptianCanyon, false, true, true, 1.5, true);
    rmSetAreaCliffHeight(EgyptianCanyon, rmRandInt(-5, -8), 1.0, 1.0);
    rmSetAreaHeightBlend(EgyptianCanyon, 2); 
    rmBuildArea(EgyptianCanyon);
  }

  int ClassOpenEgyptianCliff=rmDefineClass("Open egyptian cliff");
  int AvoidOpenEgyptianCliff=rmCreateClassDistanceConstraint("Avoid open egyptian cliff", rmClassID("Open egyptian cliff"), 3.0);

  for(i=0; <50)
  {
    int OpenEgyptianCliff=rmCreateArea("Open egyptian cliff"+i, Desert);
    rmAddAreaToClass(OpenEgyptianCliff, ClassOpenEgyptianCliff);
    rmAddAreaConstraint(OpenEgyptianCliff, AvoidWater2);
    rmSetAreaCliffType(OpenEgyptianCliff, "Egyptian");
    rmSetAreaSize(OpenEgyptianCliff, rmAreaTilesToFraction(rmRandInt(50, 200)),
      rmAreaTilesToFraction(rmRandInt(100, 800)));
    rmSetAreaMinBlobs(OpenEgyptianCliff, 10);
    rmSetAreaMaxBlobs(OpenEgyptianCliff, 10);
    rmSetAreaMinBlobDistance(OpenEgyptianCliff, 0.0);
    rmSetAreaMaxBlobDistance(OpenEgyptianCliff, 20.0);
    rmSetAreaCliffEdge(OpenEgyptianCliff, 1, 0.6, 0.1, 1.0, 0);
    rmSetAreaCliffPainting(OpenEgyptianCliff, false, true, true, 1.5, true);
    rmSetAreaCliffHeight(OpenEgyptianCliff, rmRandInt(5, 8), 1.0, 1.0);
    rmSetAreaHeightBlend(OpenEgyptianCliff, 2); 
    rmBuildArea(OpenEgyptianCliff);
  }

  int ClassClosedEgyptianCliff=rmDefineClass("Closed egyptian cliff");
  int AvoidClosedEgyptianCliff=rmCreateClassDistanceConstraint("Avoid closed egyptian cliff", rmClassID("Closed egyptian cliff"), 3.0);

  for(i=0; <50)
  {
    int ClosedEgyptianCliff=rmCreateArea("Closed egyptian cliff"+i, Desert);
    rmAddAreaToClass(ClosedEgyptianCliff, ClassClosedEgyptianCliff);
    rmAddAreaConstraint(ClosedEgyptianCliff, AvoidWater2);
    rmSetAreaCliffType(ClosedEgyptianCliff, "Egyptian");
    rmSetAreaSize(ClosedEgyptianCliff, rmAreaTilesToFraction(rmRandInt(10, 50)),
      rmAreaTilesToFraction(rmRandInt(50, 200)));
    rmSetAreaMinBlobs(ClosedEgyptianCliff, 10);
    rmSetAreaMaxBlobs(ClosedEgyptianCliff, 10);
    rmSetAreaMinBlobDistance(ClosedEgyptianCliff, 0.0);
    rmSetAreaMaxBlobDistance(ClosedEgyptianCliff, 20.0);
    rmSetAreaTerrainType(ClosedEgyptianCliff, "CliffEgyptianA");
    rmSetAreaCliffEdge(ClosedEgyptianCliff, 1, 1.0, 0.0, 1.0, 0);
    rmSetAreaCliffPainting(ClosedEgyptianCliff, true, true, true, 1.5, false);
    rmSetAreaCliffHeight(ClosedEgyptianCliff, rmRandInt(6, 9), 1.0, 1.0);
    rmSetAreaHeightBlend(ClosedEgyptianCliff, 2); 
    rmBuildArea(ClosedEgyptianCliff);
  }

  rmSetStatusText("", 0.30);

   // Lands.

  int ClassPalmForest=rmDefineClass("Palm forest");
  int AvoidPalmForest=rmCreateClassDistanceConstraint("Avoid palm forest", rmClassID("Palm forest"), 3.0);

  for(i=0; <90)
  {
    int PalmForest=rmCreateArea("Palm forest"+i, Desert);
    rmAddAreaConstraint(PalmForest, AvoidEgyptianCanyon);
    rmAddAreaConstraint(PalmForest, AvoidOpenEgyptianCliff);
    rmAddAreaConstraint(PalmForest, AvoidClosedEgyptianCliff);
    rmAddAreaConstraint(PalmForest, AvoidSavannahWaterHole);
    rmAddAreaConstraint(PalmForest, AvoidWateringHole);
    rmAddAreaConstraint(PalmForest, AvoidPalmForest);
    rmAddAreaToClass(PalmForest, ClassPalmForest);
    rmSetAreaForestType(PalmForest, "Palm forest");
    rmSetAreaSize(PalmForest, rmAreaTilesToFraction(50),
      rmAreaTilesToFraction(200));
    rmSetAreaMinBlobs(PalmForest, 20);
    rmSetAreaMaxBlobs(PalmForest, 20);
    rmSetAreaMinBlobDistance(PalmForest, 0.0);
    rmSetAreaMaxBlobDistance(PalmForest, 40.0);
    rmSetAreaCoherence(PalmForest, 0.0);
    rmBuildArea(PalmForest);
  }

  rmSetStatusText("", 0.40);

  int ClassDenseSavannah=rmDefineClass("Dense savannah");
  int AvoidDenseSavannah=rmCreateClassDistanceConstraint("Avoid dense savannah", rmClassID("Dense savannah"), 3.0);
  int ClassSavannahForest1=rmDefineClass("Savannah forest1");
  int AvoidSavannahForest1=rmCreateClassDistanceConstraint("Avoid savannah forest1", rmClassID("Savannah forest1"), 3.0);

  int A=0;
  int B=0;
  int C=0;
  int D=0;

  for(i=0; <45)
  {
    int DenseSavannah=rmCreateArea("Dense savannah"+i, Desert);
    rmAddAreaToClass(DenseSavannah, ClassDenseSavannah);
    rmAddAreaConstraint(DenseSavannah, AvoidEgyptianCanyon);
    rmAddAreaConstraint(DenseSavannah, AvoidOpenEgyptianCliff);
    rmAddAreaConstraint(DenseSavannah, AvoidClosedEgyptianCliff);
    rmAddAreaConstraint(DenseSavannah, AvoidSavannahWaterHole);
    rmAddAreaConstraint(DenseSavannah, AvoidWateringHole);
    rmAddAreaConstraint(DenseSavannah, AvoidPalmForest);
    rmAddAreaConstraint(DenseSavannah, AvoidDenseSavannah);
    rmAddAreaConstraint(DenseSavannah, AvoidSavannahForest1);
    rmSetAreaTerrainType(DenseSavannah, "SavannahA");
    rmSetAreaSize(DenseSavannah, rmAreaTilesToFraction(500),
      rmAreaTilesToFraction(1000));
    rmSetAreaMinBlobs(DenseSavannah, 20);
    rmSetAreaMaxBlobs(DenseSavannah, 20);
    rmSetAreaMinBlobDistance(DenseSavannah, 0.0);
    rmSetAreaMaxBlobDistance(DenseSavannah, 40.0);
    rmBuildArea(DenseSavannah);

    // Dense savannah life.

    int SavannahForest1=rmCreateArea("Savannah forest1"+i, DenseSavannah);
    rmAddAreaToClass(SavannahForest1, ClassSavannahForest1);
    rmAddAreaConstraint(SavannahForest1, AvoidSavannahForest1);
    rmAddAreaConstraint(SavannahForest1, AvoidEgyptianCanyon);
    rmAddAreaConstraint(SavannahForest1, AvoidOpenEgyptianCliff);
    rmAddAreaConstraint(SavannahForest1, AvoidClosedEgyptianCliff);
    rmSetAreaForestType(SavannahForest1, "Savannah forest");
    rmSetAreaSize(SavannahForest1, rmAreaTilesToFraction(50),
      rmAreaTilesToFraction(200));
    rmSetAreaMinBlobs(SavannahForest1, 20);
    rmSetAreaMaxBlobs(SavannahForest1, 20);
    rmSetAreaMinBlobDistance(SavannahForest1, 0.0);
    rmSetAreaMaxBlobDistance(SavannahForest1, 40.0);
     rmBuildArea(SavannahForest1);

    int BlowingLeaves1=rmCreateObjectDef("Blowing leaves1"+i);
    rmAddObjectDefItem(BlowingLeaves1, "Blowing leaves", rmRandInt(0, 1), 1.0);
    rmPlaceObjectDefInArea(BlowingLeaves1, 0, SavannahForest1, rmRandInt(0, 1));

    int RainSmall1=rmCreateObjectDef("Rain small1"+i);
    rmAddObjectDefItem(RainSmall1, "Rain small", rmRandInt(0, 2), rmRandFloat(2.0, 5.0));
    rmPlaceObjectDefInArea(RainSmall1, 0, SavannahForest1, rmRandInt(0, 1));

    int Berries1=rmCreateObjectDef("Berries1"+i);
    rmAddObjectDefConstraint(Berries1, AvoidWater1);
    rmAddObjectDefItem(Berries1, "Berry bush", rmRandInt(3, 7), rmRandFloat(4.0, 7.0));
    rmPlaceObjectDefInArea(Berries1, 0, DenseSavannah, rmRandInt(1, 2));

    int SavannahFlowers1=rmCreateObjectDef("Savannah flowers1"+i);
    rmAddObjectDefConstraint(SavannahFlowers1, AvoidWater1);
    rmAddObjectDefItem(SavannahFlowers1, "Flowers", rmRandInt(0, 2), rmRandFloat(2.0, 7.0));
    rmPlaceObjectDefInArea(SavannahFlowers1, 0, DenseSavannah, rmRandInt(0, 2));

    A=rmRandInt(0, 3);
    if(A == 0)
      {
        int Zebra1=rmCreateObjectDef("Zebra1"+i);
        rmAddObjectDefConstraint(Zebra1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(Zebra1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Zebra1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Zebra1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Zebra1, "Zebra", rmRandInt(0, 5),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Zebra1, 0, DenseSavannah, 1);
      }
    else if(A == 1)
      {
        int Giraffe1=rmCreateObjectDef("Giraffe1"+i);
        rmAddObjectDefConstraint(Giraffe1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(Giraffe1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Giraffe1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Giraffe1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Giraffe1, "Giraffe", rmRandInt(0, 5),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Giraffe1, 0, DenseSavannah, 1);
      }
    else if(A == 2)
      {
        int Elephant1=rmCreateObjectDef("Elephant1"+i);
        rmAddObjectDefConstraint(Elephant1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(Elephant1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Elephant1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Elephant1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Elephant1, "Elephant", rmRandInt(0, 3),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Elephant1, 0, DenseSavannah, 1);
      }
    else if(A == 3)
      {
        int Rhinocerous1=rmCreateObjectDef("Rhinocerous1"+i);
        rmAddObjectDefConstraint(Rhinocerous1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(Rhinocerous1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Rhinocerous1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Rhinocerous1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Rhinocerous1, "Rhinocerous", rmRandInt(0, 3),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Rhinocerous1, 0, DenseSavannah, 1);
      }
    B=rmRandInt(0, 4);
    if(B == 0)
      {
        int Monkey1=rmCreateObjectDef("Monkey1"+i);
        rmAddObjectDefConstraint(Monkey1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(Monkey1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Monkey1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Monkey1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Monkey1, "Monkey", rmRandInt(0, 5),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Monkey1, 0, DenseSavannah, 1);
      }
    else if(B == 1)
      {
        int Baboon1=rmCreateObjectDef("Baboon1"+i);
        rmAddObjectDefConstraint(Baboon1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(Baboon1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Baboon1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Baboon1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Baboon1, "Baboon", rmRandInt(0, 5),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Baboon1, 0, DenseSavannah, 1);
      }
    else if(B == 2)
      {
        int Gazelle1=rmCreateObjectDef("Gazelle1"+i);
        rmAddObjectDefConstraint(Gazelle1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(Gazelle1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Gazelle1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Gazelle1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Gazelle1, "Gazelle", rmRandInt(0, 5),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Gazelle1, 0, DenseSavannah, 1);
      }
    else if(B == 3)
      {
        int Boar1=rmCreateObjectDef("Boar1"+i);
        rmAddObjectDefConstraint(Boar1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(Boar1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Boar1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Boar1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Boar1, "Boar", rmRandInt(0, 3),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Boar1, 0, DenseSavannah, 1);
      }
    else if(B == 4)
      {
        int Aurochs1=rmCreateObjectDef("Aurochs1"+i);
        rmAddObjectDefConstraint(Aurochs1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(Aurochs1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Aurochs1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Aurochs1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Aurochs1, "Aurochs", rmRandInt(0, 3),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Aurochs1, 0, DenseSavannah, 1);
      }
    C=rmRandInt(0, 2);
    if(C == 0)
      {
        int Deer1=rmCreateObjectDef("Deer1"+i);
        rmAddObjectDefConstraint(Deer1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(Deer1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Deer1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Deer1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Deer1, "Deer", rmRandInt(0, 4),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Deer1, 0, DenseSavannah, 1);
      }
    else if(C == 1)
      {
        int CrownedCrane1=rmCreateObjectDef("Crowned crane1"+i);
        rmAddObjectDefConstraint(CrownedCrane1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(CrownedCrane1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(CrownedCrane1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(CrownedCrane1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(CrownedCrane1, "Crowned crane", rmRandInt(0, 4),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(CrownedCrane1, 0, DenseSavannah, 1);
      }
    else if(C == 2)
      {
      }
    D=rmRandInt(0, 11);
    if(D == 0)
      {
        int Lion1=rmCreateObjectDef("Lion1"+i);
        rmAddObjectDefConstraint(Lion1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(Lion1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Lion1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Lion1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Lion1, "Lion", rmRandInt(0, 3),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Lion1, 0, DenseSavannah, 1);
      }
    else if(D == 1)
      {
        int Wolf1=rmCreateObjectDef("Wolf1"+i);
        rmAddObjectDefConstraint(Wolf1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(Wolf1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Wolf1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Wolf1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Wolf1, "Wolf", rmRandInt(0, 3),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Wolf1, 0, DenseSavannah, 1);
      }
    else if(D == 2)
      {
        int Hyena1=rmCreateObjectDef("Hyena1"+i);
        rmAddObjectDefConstraint(Hyena1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(Hyena1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Hyena1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Hyena1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Hyena1, "Hyena", rmRandInt(0, 3),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Hyena1, 0, DenseSavannah, 1);
      }
    else if(D == 3)
      {
        int Serpent1=rmCreateObjectDef("Serpent1"+i);
        rmAddObjectDefConstraint(Serpent1, AvoidSavannahForest1);
        rmAddObjectDefConstraint(Serpent1, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Serpent1, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Serpent1, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Serpent1, "Serpent", rmRandInt(0, 3),
          rmRandFloat(2.0, 5.0));
        rmPlaceObjectDefInArea(Serpent1, 0, DenseSavannah, 1);
      }
    else if(D == 4)
      {
      }
    else if(D == 5)
      {
      }
    else if(D == 6)
      {
      }
    else if(D == 7)
      {
      }
    else if(D == 8)
      {
      }
    else if(D == 9)
      {
      }
    else if(D == 10)
      {
      }
    else if(D == 11)
      {
      }
  }

  rmSetStatusText("", 0.50);


  int ClassSparseSavannah=rmDefineClass("Sparse savannah");
  int AvoidSparseSavannah=rmCreateClassDistanceConstraint("Avoid sparse savannah", rmClassID("Sparse savannah"), 3.0);
  int ClassSavannahForest2=rmDefineClass("Savannah forest2");
  int AvoidSavannahForest2=rmCreateClassDistanceConstraint("Avoid savannah forest2", rmClassID("Savannah forest2"), 3.0);

  for(i=0; <45)
  {
    int SparseSavannah=rmCreateArea("Sparse savannah"+i, Desert);
    rmAddAreaToClass(SparseSavannah, ClassSparseSavannah);
    rmAddAreaConstraint(SparseSavannah, AvoidEgyptianCanyon);
    rmAddAreaConstraint(SparseSavannah, AvoidOpenEgyptianCliff);
    rmAddAreaConstraint(SparseSavannah, AvoidClosedEgyptianCliff);
    rmAddAreaConstraint(SparseSavannah, AvoidSavannahWaterHole);
    rmAddAreaConstraint(SparseSavannah, AvoidWateringHole);
    rmAddAreaConstraint(SparseSavannah, AvoidPalmForest);
    rmAddAreaConstraint(SparseSavannah, AvoidDenseSavannah);
    rmAddAreaConstraint(SparseSavannah, AvoidSavannahForest1);
    rmAddAreaConstraint(SparseSavannah, AvoidSparseSavannah);
    rmAddAreaConstraint(SparseSavannah, AvoidSavannahForest2);
    rmSetAreaTerrainType(SparseSavannah, "SavannahB");
    rmSetAreaSize(SparseSavannah, rmAreaTilesToFraction(400),
      rmAreaTilesToFraction(800));
    rmSetAreaMinBlobs(SparseSavannah, 20);
    rmSetAreaMaxBlobs(SparseSavannah, 20);
    rmSetAreaMinBlobDistance(SparseSavannah, 0.0);
    rmSetAreaMaxBlobDistance(SparseSavannah, 40.0);
    rmBuildArea(SparseSavannah);

    // Sparse savannah life.

    int SavannahForest2=rmCreateArea("Savannah forest2"+i, SparseSavannah);
    rmAddAreaToClass(SavannahForest2, ClassSavannahForest2);
    rmAddAreaConstraint(SavannahForest2, AvoidSavannahForest2);
    rmAddAreaConstraint(SavannahForest2, AvoidEgyptianCanyon);
    rmAddAreaConstraint(SavannahForest2, AvoidOpenEgyptianCliff);
    rmAddAreaConstraint(SavannahForest2, AvoidClosedEgyptianCliff);
    rmSetAreaForestType(SavannahForest2, "Savannah forest");
    rmSetAreaSize(SavannahForest2, rmAreaTilesToFraction(25),
      rmAreaTilesToFraction(100));
    rmSetAreaMinBlobs(SavannahForest2, 20);
    rmSetAreaMaxBlobs(SavannahForest2, 20);
    rmSetAreaMinBlobDistance(SavannahForest2, 0.0);
    rmSetAreaMaxBlobDistance(SavannahForest2, 40.0);
    rmBuildArea(SavannahForest2);

    int BlowingLeaves2=rmCreateObjectDef("Blowing leaves2"+i);
    rmAddObjectDefItem(BlowingLeaves2, "Blowing leaves", rmRandInt(0, 1), 1.0);
    rmPlaceObjectDefInArea(BlowingLeaves2, 0, SavannahForest2, rmRandInt(0, 1));

    int RainSmall2=rmCreateObjectDef("Rain small2"+i);
    rmAddObjectDefItem(RainSmall2, "Rain small", rmRandInt(0, 2), rmRandFloat(2.0, 5.0));
    rmPlaceObjectDefInArea(RainSmall2, 0, SavannahForest2, rmRandInt(0, 1));

    int Berries2=rmCreateObjectDef("Berries2"+i);
    rmAddObjectDefConstraint(Berries2, AvoidWater1);
    rmAddObjectDefItem(Berries2, "Berry bush", rmRandInt(3, 7), rmRandFloat(4.0, 7.0));
    rmPlaceObjectDefInArea(Berries2, 0, SparseSavannah, rmRandInt(1, 2));

    int Flowers2=rmCreateObjectDef("Flowers2"+i);
    rmAddObjectDefConstraint(Flowers2, AvoidWater1);
    rmAddObjectDefItem(Flowers2, "Flowers", rmRandInt(0, 2), rmRandFloat(2.0, 7.0));
    rmPlaceObjectDefInArea(Flowers2, 0, SparseSavannah, rmRandInt(0, 2));

    A=rmRandInt(0, 3);
    if(A == 0)
      {
        int Zebra2=rmCreateObjectDef("Zebra2"+i);
        rmAddObjectDefConstraint(Zebra2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(Zebra2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Zebra2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Zebra2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Zebra2, "Zebra", rmRandInt(0, 5),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Zebra2, 0, SparseSavannah, 1);
      }
    else if(A == 1)
      {
        int Giraffe2=rmCreateObjectDef("Giraffe2"+i);
        rmAddObjectDefConstraint(Giraffe2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(Giraffe2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Giraffe2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Giraffe2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Giraffe2, "Giraffe", rmRandInt(0, 5),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Giraffe2, 0, SparseSavannah, 1);
      }
    else if(A == 2)
      {
        int Elephant2=rmCreateObjectDef("Elephant2"+i);
        rmAddObjectDefConstraint(Elephant2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(Elephant2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Elephant2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Elephant2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Elephant2, "Elephant", rmRandInt(0, 3),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Elephant2, 0, SparseSavannah, 1);
      }
    else if(A == 3)
      {
        int Rhinocerous2=rmCreateObjectDef("Rhinocerous2"+i);
        rmAddObjectDefConstraint(Rhinocerous2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(Rhinocerous2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Rhinocerous2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Rhinocerous2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Rhinocerous2, "Rhinocerous", rmRandInt(0, 3),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Rhinocerous2, 0, SparseSavannah, 1);
      }
    B=rmRandInt(0, 4);
    if(B == 0)
      {
        int Monkey2=rmCreateObjectDef("Monkey2"+i);
        rmAddObjectDefConstraint(Monkey2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(Monkey2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Monkey2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Monkey2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Monkey2, "Monkey", rmRandInt(0, 5),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Monkey2, 0, SparseSavannah, 1);
      }
    else if(B == 1)
      {
        int Baboon2=rmCreateObjectDef("Baboon2"+i);
        rmAddObjectDefConstraint(Baboon2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(Baboon2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Baboon2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Baboon2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Baboon2, "Baboon", rmRandInt(0, 5),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Baboon2, 0, SparseSavannah, 1);
      }
    else if(B == 2)
      {
        int Gazelle2=rmCreateObjectDef("Gazelle2"+i);
        rmAddObjectDefConstraint(Gazelle2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(Gazelle2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Gazelle2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Gazelle2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Gazelle2, "Gazelle", rmRandInt(0, 5),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Gazelle2, 0, SparseSavannah, 1);
      }
    else if(B == 3)
      {
        int Boar2=rmCreateObjectDef("Boar2"+i);
        rmAddObjectDefConstraint(Boar2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(Boar2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Boar2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Boar2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Boar2, "Boar", rmRandInt(0, 3),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Boar2, 0, SparseSavannah, 1);
      }
    else if(B == 4)
      {
        int Aurochs2=rmCreateObjectDef("Aurochs2"+i);
        rmAddObjectDefConstraint(Aurochs2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(Aurochs2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Aurochs2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Aurochs2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Aurochs2, "Aurochs", rmRandInt(0, 3),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Aurochs2, 0, SparseSavannah, 1);
      }
    C=rmRandInt(0, 2);
    if(C == 0)
      {
        int Deer2=rmCreateObjectDef("Deer2"+i);
        rmAddObjectDefConstraint(Deer2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(Deer2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Deer2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Deer2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Deer2, "Deer", rmRandInt(0, 4),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Deer2, 0, SparseSavannah, 1);
      }
    else if(C == 1)
      {
        int CrownedCrane2=rmCreateObjectDef("Crowned crane2"+i);
        rmAddObjectDefConstraint(CrownedCrane2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(CrownedCrane2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(CrownedCrane2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(CrownedCrane2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(CrownedCrane2, "Crowned crane", rmRandInt(0, 4),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(CrownedCrane2, 0, SparseSavannah, 1);
      }
    else if(C == 2)
      {
      }
    D=rmRandInt(0, 11);
    if(D == 0)
      {
        int Lion2=rmCreateObjectDef("Lion2"+i);
        rmAddObjectDefConstraint(Lion2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(Lion2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Lion2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Lion2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Lion2, "Lion", rmRandInt(0, 3),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Lion2, 0, SparseSavannah, 1);
      }
    else if(D == 1)
      {
        int Wolf2=rmCreateObjectDef("Wolf2"+i);
        rmAddObjectDefConstraint(Wolf2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(Wolf2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Wolf2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Wolf2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Wolf2, "Wolf", rmRandInt(0, 3),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Wolf2, 0, SparseSavannah, 1);
      }
    else if(D == 2)
      {
        int Hyena2=rmCreateObjectDef("Hyena2"+i);
        rmAddObjectDefConstraint(Hyena2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(Hyena2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Hyena2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Hyena2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Hyena2, "Hyena", rmRandInt(0, 3),
          rmRandFloat(5.0, 10.0));
        rmPlaceObjectDefInArea(Hyena2, 0, SparseSavannah, 1);
      }
    else if(D == 3)
      {
        int Serpent2=rmCreateObjectDef("Serpent2"+i);
        rmAddObjectDefConstraint(Serpent2, AvoidSavannahForest2);
        rmAddObjectDefConstraint(Serpent2, AvoidEgyptianCanyon);
        rmAddObjectDefConstraint(Serpent2, AvoidOpenEgyptianCliff);
        rmAddObjectDefConstraint(Serpent2, AvoidClosedEgyptianCliff);
        rmAddObjectDefItem(Serpent2, "Serpent", rmRandInt(0, 3),
          rmRandFloat(2.0, 5.0));
        rmPlaceObjectDefInArea(Serpent2, 0, SparseSavannah, 1);
      }
    else if(D == 4)
      {
      }
    else if(D == 5)
      {
      }
    else if(D == 6)
      {
      }
    else if(D == 7)
      {
      }
    else if(D == 8)
      {
      }
    else if(D == 9)
      {
      }
    else if(D == 10)
      {
      }
    else if(D == 11)
      {
      }
  }

  rmSetStatusText("", 0.75);

  int OldRelic=rmCreateObjectDef("Old relic");
  rmAddObjectDefItem(OldRelic, "Relic", 1, 0.0);
  rmPlaceObjectDefInArea(OldRelic, 0, Desert, 40);

  int Gold=rmCreateObjectDef("Gold");
  rmAddObjectDefConstraint(Gold, AvoidWater1);
  rmAddObjectDefItem(Gold, "Gold mine", 1, 0.0);
  rmPlaceObjectDefInArea(Gold, 0, Desert, 20);

  int SmallGold=rmCreateObjectDef("Small gold");
  rmAddObjectDefConstraint(SmallGold, AvoidWater1);
  rmAddObjectDefItem(SmallGold, "Gold mine Small", 1, 0.0);
  rmPlaceObjectDefInArea(SmallGold, 0, Desert, 40);

  int TinyGold=rmCreateObjectDef("Tiny gold");
  rmAddObjectDefConstraint(TinyGold, AvoidWater1);
  rmAddObjectDefItem(TinyGold, "Gold mine tiny", 1, 0.0);
  rmPlaceObjectDefInArea(TinyGold, 0, Desert, 40);

  rmSetStatusText("", 0.80);

  // Player 1 start.

  int GreekVillager=rmCreateObjectDef("Greek villager");
  rmAddObjectDefConstraint(GreekVillager, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(GreekVillager, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(GreekVillager, AvoidClosedEgyptianCliff);
  rmAddObjectDefConstraint(GreekVillager, AvoidSavannahWaterHole);
  rmAddObjectDefConstraint(GreekVillager, AvoidWateringHole);
  rmAddObjectDefConstraint(GreekVillager, AvoidPalmForest);
  rmAddObjectDefConstraint(GreekVillager, AvoidSavannahForest1);
  rmAddObjectDefConstraint(GreekVillager, AvoidSavannahForest2);
  rmAddObjectDefItem(GreekVillager, "Villager Greek", 1, 0.0);

  int EgyptianVillager=rmCreateObjectDef("Egyptian villager");
  rmAddObjectDefConstraint(EgyptianVillager, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(EgyptianVillager, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(EgyptianVillager, AvoidClosedEgyptianCliff);
  rmAddObjectDefConstraint(EgyptianVillager, AvoidSavannahWaterHole);
  rmAddObjectDefConstraint(EgyptianVillager, AvoidWateringHole);
  rmAddObjectDefConstraint(EgyptianVillager, AvoidPalmForest);
  rmAddObjectDefConstraint(EgyptianVillager, AvoidSavannahForest1);
  rmAddObjectDefConstraint(EgyptianVillager, AvoidSavannahForest2);
  rmAddObjectDefItem(EgyptianVillager, "Villager Egyptian", 1, 0.0);

  int NorseVillager=rmCreateObjectDef("Norse villager ");
  rmAddObjectDefConstraint(NorseVillager, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(NorseVillager, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(NorseVillager, AvoidClosedEgyptianCliff);
  rmAddObjectDefConstraint(NorseVillager, AvoidSavannahWaterHole);
  rmAddObjectDefConstraint(NorseVillager, AvoidWateringHole);
  rmAddObjectDefConstraint(NorseVillager, AvoidPalmForest);
  rmAddObjectDefConstraint(NorseVillager, AvoidSavannahForest1);
  rmAddObjectDefConstraint(NorseVillager, AvoidSavannahForest2);
  rmAddObjectDefItem(NorseVillager, "Villager Norse", 1, 0.0);

  int NorseDwarf=rmCreateObjectDef("Norse dwarf ");
  rmAddObjectDefConstraint(NorseDwarf, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(NorseDwarf, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(NorseDwarf, AvoidClosedEgyptianCliff);
  rmAddObjectDefConstraint(NorseDwarf, AvoidSavannahWaterHole);
  rmAddObjectDefConstraint(NorseDwarf, AvoidWateringHole);
  rmAddObjectDefConstraint(NorseDwarf, AvoidPalmForest);
  rmAddObjectDefConstraint(NorseDwarf, AvoidSavannahForest1);
  rmAddObjectDefConstraint(NorseDwarf, AvoidSavannahForest2);
  rmAddObjectDefItem(NorseDwarf, "Dwarf", 1, 0.0);

  int NorseUlfsark=rmCreateObjectDef("Norse Ulfsark");
  rmAddObjectDefConstraint(NorseUlfsark, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(NorseUlfsark, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(NorseUlfsark, AvoidClosedEgyptianCliff);
  rmAddObjectDefConstraint(NorseUlfsark, AvoidSavannahWaterHole);
  rmAddObjectDefConstraint(NorseUlfsark, AvoidWateringHole);
  rmAddObjectDefConstraint(NorseUlfsark, AvoidPalmForest);
  rmAddObjectDefConstraint(NorseUlfsark, AvoidSavannahForest1);
  rmAddObjectDefConstraint(NorseUlfsark, AvoidSavannahForest2);
  rmAddObjectDefItem(NorseUlfsark, "Ulfsark", 1, 0.0);

  int NorseOxCart=rmCreateObjectDef("Norse Ox Cart");
  rmAddObjectDefConstraint(NorseOxCart, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(NorseOxCart, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(NorseOxCart, AvoidClosedEgyptianCliff);
  rmAddObjectDefConstraint(NorseOxCart, AvoidSavannahWaterHole);
  rmAddObjectDefConstraint(NorseOxCart, AvoidWateringHole);
  rmAddObjectDefConstraint(NorseOxCart, AvoidPalmForest);
  rmAddObjectDefConstraint(NorseOxCart, AvoidSavannahForest1);
  rmAddObjectDefConstraint(NorseOxCart, AvoidSavannahForest2);
  rmAddObjectDefItem(NorseOxCart, "Ox Cart", 1, 0.0);

  rmSetStatusText("", 0.85);

  int playerculture = 0;

  for(i=0; <cNumberPlayers-1)
    {
      playerculture = rmGetPlayerCulture(i);
    }

  for(i=0; <cNumberPlayers-1)
    {
      if(rmGetPlayerCulture(i) == cCultureGreek)
        {
          rmPlaceObjectDefInArea(GreekVillager, i, Desert, 1);
          rmAddPlayerResource(i, "Food", -250);
          rmAddPlayerResource(i, "Wood", -200);
          rmAddPlayerResource(i, "Gold", -100);
        }
      else if(rmGetPlayerCulture(i) == cCultureEgyptian)
        {
          rmPlaceObjectDefInArea(EgyptianVillager, i, Desert, 1);
          rmAddPlayerResource(i, "Food", -250);
          rmAddPlayerResource(i, "Wood", -150);
          rmAddPlayerResource(i, "Gold", -100);
        }
      else if(rmGetPlayerCulture(i) == cCultureNorse)
        {
          float Chance=rmRandFloat(0, 1);
          if(Chance<0.5)   
            rmPlaceObjectDefInArea(NorseVillager, i, Desert, 1);
          else
            rmPlaceObjectDefInArea(NorseDwarf, i, Desert, 1);
            rmPlaceObjectDefInArea(NorseUlfsark, i, Desert, 1);
            rmPlaceObjectDefInArea(NorseOxCart, i, Desert, 1);
            rmAddPlayerResource(i, "Food", -250);
            rmAddPlayerResource(i, "Wood", -200);
            rmAddPlayerResource(i, "Gold", -150);
        }
      }

  // Computer's [Player 2.] starting population.

  int ComputerSettlement=rmCreateObjectDef("Computer settlement");
  rmAddObjectDefConstraint(ComputerSettlement, AvoidWater1);
  rmAddObjectDefItem(ComputerSettlement, "Settlement Level 1", 1, 0.0);
  rmSetObjectDefMinDistance(ComputerSettlement, 0.0);
  rmSetObjectDefMaxDistance(ComputerSettlement, 0.0);

  rmPlacePlayer(2, rmRandFloat(0.0, 1.0), rmRandFloat(0.0, 1.0));
  rmPlaceObjectDefInArea(ComputerSettlement, 2, Desert, 1);

  // Air life.

  int Vulture=rmCreateObjectDef("Vulture");
  rmAddObjectDefItem(Vulture, "Vulture", 1, 0.0);
  rmPlaceObjectDefInArea(Vulture, 0, Desert, 10);
  
  int Hawk=rmCreateObjectDef("Hawk");
  rmAddObjectDefItem(Hawk, "Hawk", 1, 0.0);
  rmPlaceObjectDefInArea(Hawk, 0, Desert, 10);

  // Vegetation.

  int Bush=rmCreateObjectDef("Bush");
  rmAddObjectDefConstraint(Bush, AvoidWater1);
  rmAddObjectDefItem(Bush, "Bush", rmRandInt(1, 3), rmRandFloat(2.0, 5.0));
  rmPlaceObjectDefInArea(Bush, 0, Desert, 500);

  int Grass=rmCreateObjectDef("Grass");
  rmAddObjectDefConstraint(Grass, AvoidWater1);
  rmAddObjectDefItem(Grass, "Grass", rmRandInt(1, 3), rmRandFloat(2.0, 5.0));
  rmPlaceObjectDefInArea(Grass, 0, Desert, 500);

  // Miscellaneous.

  int NearWater=rmCreateTerrainMaxDistanceConstraint("Near water", "Water", true, 1.0);

  for(i=0; <10)
  {
  int Crocodile=rmCreateObjectDef("Crocodile"+i);
  rmAddObjectDefConstraint(Crocodile, NearWater);
  rmAddObjectDefConstraint(Crocodile, AvoidPalmForest);
  rmAddObjectDefConstraint(Crocodile, AvoidSavannahForest1);
  rmAddObjectDefConstraint(Crocodile, AvoidSavannahForest2);
  rmAddObjectDefItem(Crocodile, "Crocodile", rmRandInt(0, 3), rmRandFloat(3.0, 10.0));
  rmPlaceObjectDefInArea(Crocodile, 0, Desert, 1);

  int Hippopotamus=rmCreateObjectDef("Hippopotamus"+i);
  rmAddObjectDefConstraint(Hippopotamus, NearWater);
  rmAddObjectDefConstraint(Hippopotamus, AvoidPalmForest);
  rmAddObjectDefConstraint(Hippopotamus, AvoidSavannahForest1);
  rmAddObjectDefConstraint(Hippopotamus, AvoidSavannahForest2);
  rmAddObjectDefItem(Hippopotamus, "Hippo", rmRandInt(0, 3), rmRandFloat(3.0, 15.0));
  rmPlaceObjectDefInArea(Hippopotamus, 0, Desert, 1);

  int WaterBuffalo=rmCreateObjectDef("Water buffalo"+i);
  rmAddObjectDefConstraint(WaterBuffalo, NearWater);
  rmAddObjectDefConstraint(WaterBuffalo, AvoidPalmForest);
  rmAddObjectDefConstraint(WaterBuffalo, AvoidSavannahForest1);
  rmAddObjectDefConstraint(WaterBuffalo, AvoidSavannahForest2);
  rmAddObjectDefItem(WaterBuffalo, "Water buffalo", rmRandInt(0, 3), rmRandFloat(3.0, 15.0));
  rmPlaceObjectDefInArea(WaterBuffalo, 0, Desert, 1);

  int ErebusShade=rmCreateObjectDef("Erebus shade"+i);
  rmAddObjectDefConstraint(ErebusShade, AvoidWater1);
  rmAddObjectDefConstraint(ErebusShade, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(ErebusShade, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(ErebusShade, AvoidClosedEgyptianCliff);
  rmAddObjectDefConstraint(ErebusShade, AvoidPalmForest);
  rmAddObjectDefConstraint(ErebusShade, AvoidSavannahForest1);
  rmAddObjectDefConstraint(ErebusShade, AvoidSavannahForest2);
  rmAddObjectDefItem(ErebusShade, "Shade of erebus", rmRandInt(0, 3), rmRandFloat(3.0, 10.0));
  rmPlaceObjectDefInArea(ErebusShade, 0, Desert, 1);

  int Shade=rmCreateObjectDef("Shade"+i);
  rmAddObjectDefConstraint(Shade, AvoidWater1);
  rmAddObjectDefConstraint(Shade, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(Shade, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(Shade, AvoidClosedEgyptianCliff);
  rmAddObjectDefConstraint(Shade, AvoidPalmForest);
  rmAddObjectDefConstraint(Shade, AvoidSavannahForest1);
  rmAddObjectDefConstraint(Shade, AvoidSavannahForest2);
  rmAddObjectDefItem(Shade, "Shade", rmRandInt(0, 3), rmRandFloat(3.0, 10.0));
  rmPlaceObjectDefInArea(Shade, 0, Desert, 1);

  int Mist1=rmCreateObjectDef("Mist1"+i);
  rmAddObjectDefConstraint(Mist1, NearWater);
  rmAddObjectDefItem(Mist1, "Mist", 1, 0.0);
  rmPlaceObjectDefInArea(Mist1, 0, Desert, 1);

  int SandDriftDune=rmCreateObjectDef("Sand drift dune"+i);
  rmAddObjectDefItem(SandDriftDune, "Sand drift dune", 1, 0.0);
  rmPlaceObjectDefInArea(SandDriftDune, 0, Desert, 1);

  int SandDriftPatch=rmCreateObjectDef("Sand drift patch"+i);
  rmAddObjectDefItem(SandDriftPatch, "Sand drift patch", 1, 0.0);
  rmPlaceObjectDefInArea(SandDriftPatch, 0, Desert, 1);

  int SandDriftPlain=rmCreateObjectDef("Sand drift plain"+i);
  rmAddObjectDefItem(SandDriftPlain, "Sand drift plain", 1, 0.0);
  rmPlaceObjectDefInArea(SandDriftPlain, 0, Desert, 1);

  int DustDevil=rmCreateObjectDef("Dust devil"+i);
  rmAddObjectDefConstraint(DustDevil, AvoidWater1);
  rmAddObjectDefItem(DustDevil, "Dust devil", 1, 0.0);
  rmPlaceObjectDefInArea(DustDevil, 0, Desert, 1);

  int LightningCloud=rmCreateObjectDef("Lightning cloud"+i);
  rmAddObjectDefItem(LightningCloud, "Lightning cloud", 1, 0.0);
  rmPlaceObjectDefInArea(LightningCloud, 0, Desert, 1);
  }

  rmSetStatusText("", 0.95);

  for(i=0; <30)
  {
  int Mist2=rmCreateObjectDef("Mist2"+i);
  rmAddObjectDefConstraint(Mist2, AvoidLand4);
  rmAddObjectDefItem(Mist2, "Mist", 1, 0.0);
  rmSetObjectDefMinDistance(Mist2, 0.0);
  rmSetObjectDefMaxDistance(Mist2, 500);
  rmPlaceObjectDefAtLoc(Mist2, 0, 0.5, 0.5, 1);

  int RockSandstoneSprite=rmCreateObjectDef("Rock sandstone sprite"+i);
  rmAddObjectDefConstraint(RockSandstoneSprite, AvoidWater1);
  rmAddObjectDefConstraint(RockSandstoneSprite, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(RockSandstoneSprite, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(RockSandstoneSprite, AvoidClosedEgyptianCliff);
  rmAddObjectDefItem(RockSandstoneSprite, "Rock sandstone sprite", rmRandInt(1, 2), rmRandFloat(3.0, 10.0));
  rmPlaceObjectDefInArea(RockSandstoneSprite, 0, Desert, 1);

  int RockSandstoneSmall=rmCreateObjectDef("Rock sandstone small"+i);
  rmAddObjectDefConstraint(RockSandstoneSmall, AvoidWater1);
  rmAddObjectDefConstraint(RockSandstoneSmall, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(RockSandstoneSmall, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(RockSandstoneSmall, AvoidClosedEgyptianCliff);
  rmAddObjectDefItem(RockSandstoneSmall, "Rock sandstone small", rmRandInt(1, 2), rmRandFloat(3.0, 10.0));
  rmPlaceObjectDefInArea(RockSandstoneSmall, 0, Desert, 1);

  int RockSandstoneBig=rmCreateObjectDef("Rock sandstone big"+i);
  rmAddObjectDefConstraint(RockSandstoneBig, AvoidWater1);
  rmAddObjectDefConstraint(RockSandstoneBig, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(RockSandstoneBig, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(RockSandstoneBig, AvoidClosedEgyptianCliff);
  rmAddObjectDefItem(RockSandstoneBig, "Rock sandstone big", rmRandInt(1, 2), rmRandFloat(3.0, 10.0));
  rmPlaceObjectDefInArea(RockSandstoneBig, 0, Desert, 1);

  int RockLimestoneSprite=rmCreateObjectDef("Rock limestone sprite"+i);
  rmAddObjectDefConstraint(RockLimestoneSprite, AvoidWater1);
  rmAddObjectDefConstraint(RockLimestoneSprite, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(RockLimestoneSprite, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(RockLimestoneSprite, AvoidClosedEgyptianCliff);
  rmAddObjectDefItem(RockLimestoneSprite, "Rock limestone sprite", rmRandInt(1, 2), rmRandFloat(3.0, 10.0));
  rmPlaceObjectDefInArea(RockLimestoneSprite, 0, Desert, 1);

  int RockLimestoneSmall=rmCreateObjectDef("Rock limestone small"+i);
  rmAddObjectDefConstraint(RockLimestoneSmall, AvoidWater1);
  rmAddObjectDefConstraint(RockLimestoneSmall, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(RockLimestoneSmall, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(RockLimestoneSmall, AvoidClosedEgyptianCliff);
  rmAddObjectDefItem(RockLimestoneSmall, "Rock limestone small", rmRandInt(1, 2), rmRandFloat(3.0, 10.0));
  rmPlaceObjectDefInArea(RockLimestoneSmall, 0, Desert, 1);

  int RockLimestoneBig=rmCreateObjectDef("Rock limestone big"+i);
  rmAddObjectDefConstraint(RockLimestoneBig, AvoidWater1);
  rmAddObjectDefConstraint(RockLimestoneBig, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(RockLimestoneBig, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(RockLimestoneBig, AvoidClosedEgyptianCliff);
  rmAddObjectDefItem(RockLimestoneBig, "Rock limestone big", rmRandInt(1, 2), rmRandFloat(3.0, 10.0));
  rmPlaceObjectDefInArea(RockLimestoneBig, 0, Desert, 1);

  int RockGraniteSmall=rmCreateObjectDef("Rock granite small"+i);
  rmAddObjectDefConstraint(RockGraniteSmall, AvoidWater1);
  rmAddObjectDefConstraint(RockGraniteSmall, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(RockGraniteSmall, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(RockGraniteSmall, AvoidClosedEgyptianCliff);
  rmAddObjectDefItem(RockGraniteSmall, "Rock granite small", rmRandInt(1, 2), rmRandFloat(3.0, 10.0));
  rmPlaceObjectDefInArea(RockGraniteSmall, 0, Desert, 1);

  int RockGraniteBig=rmCreateObjectDef("Rock granite big"+i);
  rmAddObjectDefConstraint(RockGraniteBig, AvoidWater1);
  rmAddObjectDefConstraint(RockGraniteBig, AvoidEgyptianCanyon);
  rmAddObjectDefConstraint(RockGraniteBig, AvoidOpenEgyptianCliff);
  rmAddObjectDefConstraint(RockGraniteBig, AvoidClosedEgyptianCliff);
  rmAddObjectDefItem(RockGraniteBig, "Rock granite big", rmRandInt(1, 2), rmRandFloat(3.0, 10.0));
  rmPlaceObjectDefInArea(RockGraniteBig, 0, Desert, 1);
  }

  rmSetStatusText("", 1.00);

}